diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/print_packet.c olsrd-current/src/print_packet.c
--- olsrd-0.5.0/src/print_packet.c	2006-01-07 09:16:20.000000000 +0100
+++ olsrd-current/src/print_packet.c	2007-04-22 22:25:48.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: print_packet.c,v 1.9 2006/01/07 08:16:20 kattemat Exp $
+ * $Id: print_packet.c,v 1.10 2007/04/22 20:25:48 bernd67 Exp $
  */
 
 #include "print_packet.h"
@@ -55,10 +55,10 @@
 print_hnamsg(FILE *, olsr_u8_t *, olsr_16_t);
 
 static void
-print_tcmsg(FILE *, olsr_u8_t *, olsr_16_t);
+print_olsr_tcmsg(FILE *, olsr_u8_t *, olsr_16_t);
 
 static void
-print_tcmsg_lq(FILE *, olsr_u8_t *, olsr_16_t);
+print_olsr_tcmsg_lq(FILE *, olsr_u8_t *, olsr_16_t);
 
 static void
 print_hellomsg(FILE *, olsr_u8_t *, olsr_16_t);
@@ -131,13 +131,13 @@
 		   ntohs(msg->v4.olsr_msgsize));
       break;
     case(TC_MESSAGE):
-      print_tcmsg(handle,
+      print_olsr_tcmsg(handle,
 		  (olsr_cnf->ip_version == AF_INET) ? 
 		  (olsr_u8_t *)&msg->v4.message : (olsr_u8_t *)&msg->v6.message,
 		  ntohs(msg->v4.olsr_msgsize));
       break;
     case(LQ_TC_MESSAGE):
-      print_tcmsg_lq(handle,
+      print_olsr_tcmsg_lq(handle,
 		     (olsr_cnf->ip_version == AF_INET) ? 
 		     (olsr_u8_t *)&msg->v4.message : (olsr_u8_t *)&msg->v6.message,
 		     ntohs(msg->v4.olsr_msgsize));
@@ -323,11 +323,11 @@
 }
 
 static void
-print_tcmsg_lq(FILE *handle, olsr_u8_t *data, olsr_16_t totsize)
+print_olsr_tcmsg_lq(FILE *handle, olsr_u8_t *data, olsr_16_t totsize)
 {
   int remsize = totsize - ((olsr_cnf->ip_version == AF_INET) ? OLSR_MSGHDRSZ_IPV4 : OLSR_MSGHDRSZ_IPV6);
   
-  fprintf(handle, "    +ANSN: %d\n", htons(((struct tcmsg *)data)->ansn));
+  fprintf(handle, "    +ANSN: %d\n", htons(((struct olsr_tcmsg *)data)->ansn));
 
   data += 4;
   remsize -= 4;
@@ -347,11 +347,11 @@
 
 
 static void
-print_tcmsg(FILE *handle, olsr_u8_t *data, olsr_16_t totsize)
+print_olsr_tcmsg(FILE *handle, olsr_u8_t *data, olsr_16_t totsize)
 {
   int remsize = totsize - ((olsr_cnf->ip_version == AF_INET) ? OLSR_MSGHDRSZ_IPV4 : OLSR_MSGHDRSZ_IPV6);
   
-  fprintf(handle, "    +ANSN: %d\n", htons(((struct tcmsg *)data)->ansn));
+  fprintf(handle, "    +ANSN: %d\n", htons(((struct olsr_tcmsg *)data)->ansn));
 
   data += 4;
   remsize -= 4;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/process_package.c olsrd-current/src/process_package.c
--- olsrd-0.5.0/src/process_package.c	2007-02-10 20:27:32.000000000 +0100
+++ olsrd-current/src/process_package.c	2007-04-26 00:08:13.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: process_package.c,v 1.38 2007/02/10 19:27:32 bernd67 Exp $
+ * $Id: process_package.c,v 1.40 2007/04/25 22:08:13 bernd67 Exp $
  */
 
 
@@ -60,7 +60,7 @@
  *Initializing the parser functions we are using
  */
 void
-olsr_init_package_process()
+olsr_init_package_process(void)
 {
   if (olsr_cnf->lq_level == 0)
     {
@@ -81,21 +81,19 @@
 olsr_hello_tap(struct hello_message *message, struct interface *in_if,
                union olsr_ip_addr *from_addr)
 {
-  struct link_entry         *link;
   struct neighbor_entry     *neighbor;
-  struct hello_neighbor *walker;
-  double saved_lq;
-  double rel_lq;
 
   /*
    * Update link status
    */
-  link = update_link_entry(&in_if->ip_addr, from_addr, message, in_if);
+  struct link_entry         *link = update_link_entry(&in_if->ip_addr, from_addr, message, in_if);
 
   if (olsr_cnf->lq_level > 0)
     {
+      double saved_lq;
+      double rel_lq;
+      struct hello_neighbor *walker;
       // just in case our neighbor has changed its HELLO interval
-
       olsr_update_packet_loss_hello_int(link, message->htime);
 
       // find the input interface in the list of neighbor interfaces
@@ -136,7 +134,7 @@
           }
 
           else
-            OLSR_PRINTF(3, "Skipping Dijkstra (2)\n")
+            OLSR_PRINTF(3, "Skipping Dijkstra (2)\n");
 
           // create a new ANSN
 
@@ -172,7 +170,7 @@
       OLSR_PRINTF(1, "Willingness for %s changed from %d to %d - UPDATING\n", 
 		  olsr_ip_to_string(&neighbor->neighbor_main_addr),
 		  neighbor->willingness,
-		  message->willingness)
+		  message->willingness);
       /*
        *If willingness changed - recalculate
        */
@@ -231,7 +229,7 @@
     }
 
   OLSR_PRINTF(3, "Processing TC from %s\n",
-              olsr_ip_to_string(&message->originator))
+              olsr_ip_to_string(&message->originator));
 
   /*
    *      If the sender interface (NB: not originator) of this message
@@ -242,7 +240,7 @@
   if(check_neighbor_link(from_addr) != SYM_LINK)
     {
       OLSR_PRINTF(2, "Received TC from NON SYM neighbor %s\n",
-                  olsr_ip_to_string(from_addr))
+                  olsr_ip_to_string(from_addr));
       olsr_free_tc_packet(message);
       return;
     }
@@ -250,15 +248,15 @@
   if(olsr_cnf->debug_level > 2)
     {
       mpr = message->multipoint_relay_selector_address;
-      OLSR_PRINTF(3, "mpr_selector_list:[")
+      OLSR_PRINTF(3, "mpr_selector_list:[");
 
       while(mpr!=NULL)
         {
-          OLSR_PRINTF(3, "%s:", olsr_ip_to_string(&mpr->address))
+          OLSR_PRINTF(3, "%s:", olsr_ip_to_string(&mpr->address));
           mpr=mpr->next;
         }
 
-      OLSR_PRINTF(3, "]\n")
+      OLSR_PRINTF(3, "]\n");
     }
 
   tc_last = olsr_lookup_tc_entry(&message->originator);
@@ -296,7 +294,7 @@
       else
         {
           OLSR_PRINTF(3, "Dropping empty TC from %s\n",
-                      olsr_ip_to_string(&message->originator))
+                      olsr_ip_to_string(&message->originator));
         }
     }
 
@@ -374,7 +372,7 @@
     }
 
 #ifdef DEBUG
-  OLSR_PRINTF(5, "Processing MID from %s...\n", olsr_ip_to_string(&message.mid_origaddr))
+  OLSR_PRINTF(5, "Processing MID from %s...\n", olsr_ip_to_string(&message.mid_origaddr));
 #endif
   tmp_adr = message.mid_addr;
 
@@ -386,7 +384,7 @@
 
   if(check_neighbor_link(from_addr) != SYM_LINK)
     {
-      OLSR_PRINTF(2, "Received MID from NON SYM neighbor %s\n", olsr_ip_to_string(from_addr))
+      OLSR_PRINTF(2, "Received MID from NON SYM neighbor %s\n", olsr_ip_to_string(from_addr));
       olsr_free_mid_packet(&message);
       return;
     }
@@ -398,8 +396,8 @@
     {
       if(!mid_lookup_main_addr(&tmp_adr->alias_addr))
 	{
-	  OLSR_PRINTF(1, "MID new: (%s, ", olsr_ip_to_string(&message.mid_origaddr))
-	  OLSR_PRINTF(1, "%s)\n", olsr_ip_to_string(&tmp_adr->alias_addr))
+	  OLSR_PRINTF(1, "MID new: (%s, ", olsr_ip_to_string(&message.mid_origaddr));
+	  OLSR_PRINTF(1, "%s)\n", olsr_ip_to_string(&tmp_adr->alias_addr));
 	  insert_mid_alias(&message.mid_origaddr, &tmp_adr->alias_addr, (float)message.vtime);
 	}
 
@@ -440,7 +438,7 @@
   struct  hna_message message;
 
 #ifdef DEBUG
-  OLSR_PRINTF(5, "Processing HNA\n")
+  OLSR_PRINTF(5, "Processing HNA\n");
 #endif
 
   hna_chgestruct(&message, m);
@@ -466,7 +464,7 @@
    */
   if(check_neighbor_link(from_addr) != SYM_LINK)
     {
-      OLSR_PRINTF(2, "Received HNA from NON SYM neighbor %s\n", olsr_ip_to_string(from_addr))
+      OLSR_PRINTF(2, "Received HNA from NON SYM neighbor %s\n", olsr_ip_to_string(from_addr));
       olsr_free_hna_packet(&message);
       return;
     }
@@ -540,7 +538,7 @@
 	  struct neighbor_2_list_entry *two_hop_neighbor_yet =
             olsr_lookup_my_neighbors(neighbor, &message_neighbors->address);
 #ifdef DEBUG
-          OLSR_PRINTF(7, "\tProcessing %s\n", olsr_ip_to_string(&message_neighbors->address))
+          OLSR_PRINTF(7, "\tProcessing %s\n", olsr_ip_to_string(&message_neighbors->address));
 #endif
           if (two_hop_neighbor_yet != NULL)
             {
@@ -582,7 +580,7 @@
 #ifdef DEBUG
                   OLSR_PRINTF(5, 
 			      "Adding 2 hop neighbor %s\n\n", 
-			      olsr_ip_to_string(&message_neighbors->address))
+			      olsr_ip_to_string(&message_neighbors->address));
 #endif
                   changes_neighborhood = OLSR_TRUE;
                   changes_topology = OLSR_TRUE;
@@ -773,7 +771,7 @@
                           }
 
                           else
-                            OLSR_PRINTF(3, "Skipping Dijkstra (3)\n")
+                            OLSR_PRINTF(3, "Skipping Dijkstra (3)\n");
                         }
                     }
                 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/process_routes.c olsrd-current/src/process_routes.c
--- olsrd-0.5.0/src/process_routes.c	2007-01-31 13:36:50.000000000 +0100
+++ olsrd-current/src/process_routes.c	2007-05-14 00:23:55.000000000 +0200
@@ -39,7 +39,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: process_routes.c,v 1.30 2007/01/31 12:36:50 bernd67 Exp $
+ * $Id: process_routes.c,v 1.33 2007/05/13 22:23:55 bernd67 Exp $
  */
 
 #include "defs.h"
@@ -148,7 +148,7 @@
 }
 
 void 
-olsr_init_export_route() 
+olsr_init_export_route(void)
 {
   olsr_addroute_add_function(&olsr_ioctl_add_route, AF_INET);
   olsr_addroute_add_function(&olsr_ioctl_add_route6, AF_INET6);
@@ -211,7 +211,7 @@
 
 
 int
-olsr_init_old_table()
+olsr_init_old_table(void)
 {
   int index;
 
@@ -238,20 +238,16 @@
 int
 olsr_find_up_route(struct rt_entry *dst, struct rt_entry *table)
 { 
-  struct rt_entry *destination;
-  olsr_u32_t      hash;
- 
-  hash = olsr_hashing(&dst->rt_dst);
+  struct rt_entry  *destination;
+  const olsr_u32_t  hash = olsr_hashing(&dst->rt_dst);
 
-  for(destination = table[hash].next;
-      destination != &table[hash];
-      destination = destination->next)
+  for(destination = table[hash].next; destination != &table[hash]; destination = destination->next)
     {
       //printf("Checking %s hc: %d ", olsr_ip_to_string(&dst->rt_dst), dst->rt_metric);
       //printf("vs %s hc: %d ... ", olsr_ip_to_string(&destination->rt_dst), destination->rt_metric);      
       if (COMP_IP(&destination->rt_dst, &dst->rt_dst) &&
 	  COMP_IP(&destination->rt_router, &dst->rt_router) &&
-	  (destination->rt_if->if_nr == dst->rt_if->if_nr))
+	  (destination->rt_if->if_index == dst->rt_if->if_index))
 	{
 	  if(destination->rt_metric == dst->rt_metric)
 	    {
@@ -263,9 +259,7 @@
 	    }
 	}
     }
-
   return 0;
-
 }
 
 
@@ -318,42 +312,33 @@
  *@return 1
  */
 int
-olsr_delete_all_kernel_routes()
+olsr_delete_all_kernel_routes(void)
 { 
-  struct destination_n *delete_kernel_list = NULL;
-  struct destination_n *tmp = NULL;
-  union olsr_ip_addr *tmp_addr;
+  struct destination_n *delete_kernel_list;
+  struct destination_n *tmp;
 
-  OLSR_PRINTF(1, "Deleting all routes...\n")
+  OLSR_PRINTF(1, "Deleting all routes...\n");
 
   delete_kernel_list = olsr_build_update_list(hna_routes, old_hna);
 
-  tmp = delete_kernel_list;
-
-  OLSR_PRINTF(1, "HNA list:\n")
-  while(tmp)
+  OLSR_PRINTF(1, "HNA list:\n");
+  for(tmp = delete_kernel_list;tmp;tmp = tmp->next)
     {
-      tmp_addr = &tmp->destination->rt_dst;
-      OLSR_PRINTF(1, "Dest: %s\n", olsr_ip_to_string(tmp_addr))
-      tmp = tmp->next;
+      union olsr_ip_addr *tmp_addr = &tmp->destination->rt_dst;
+      OLSR_PRINTF(1, "Dest: %s\n", olsr_ip_to_string(tmp_addr));
     }
 
   olsr_delete_routes_from_kernel(delete_kernel_list);
 
   delete_kernel_list = olsr_build_update_list(routingtable,old_routes);
 
-  tmp = delete_kernel_list;
-
-  OLSR_PRINTF(1, "Route list:\n")
-  while(tmp)
+  OLSR_PRINTF(1, "Route list:\n");
+  for(tmp = delete_kernel_list;tmp;tmp = tmp->next)
     {
-      tmp_addr = &tmp->destination->rt_dst;
-      OLSR_PRINTF(1, "Dest: %s\n", olsr_ip_to_string(tmp_addr))
-      tmp = tmp->next;
+      union olsr_ip_addr *tmp_addr = &tmp->destination->rt_dst;
+      OLSR_PRINTF(1, "Dest: %s\n", olsr_ip_to_string(tmp_addr));
     }
-
   olsr_delete_routes_from_kernel(delete_kernel_list);
-
   return 1;
 }
 
@@ -365,12 +350,12 @@
  *@return nada
  */
 void
-olsr_update_kernel_routes()
+olsr_update_kernel_routes(void)
 {
-  struct destination_n *delete_kernel_list = NULL;
-  struct destination_n *add_kernel_list = NULL;
+  struct destination_n *delete_kernel_list;
+  struct destination_n *add_kernel_list;
 
-  OLSR_PRINTF(3, "Updating kernel routes...\n")
+  OLSR_PRINTF(3, "Updating kernel routes...\n");
   delete_kernel_list = olsr_build_update_list(old_routes, routingtable);
   add_kernel_list = olsr_build_update_list(routingtable, old_routes);
 
@@ -387,14 +372,12 @@
  *@return nada
  */
 void
-olsr_update_kernel_hna_routes()
+olsr_update_kernel_hna_routes(void)
 {
-  struct destination_n *delete_kernel_list = NULL;
-  //struct destination_n *delete_kernel_list2;
-  struct destination_n *add_kernel_list = NULL;
-
-  OLSR_PRINTF(3, "Updating kernel HNA routes...\n")
+  struct destination_n *delete_kernel_list;
+  struct destination_n *add_kernel_list;
 
+  OLSR_PRINTF(3, "Updating kernel HNA routes...\n");
 
   delete_kernel_list = olsr_build_update_list(old_hna, hna_routes);
   add_kernel_list = olsr_build_update_list(hna_routes, old_hna);
@@ -467,7 +450,7 @@
 
 #ifdef DEBUG
   OLSR_PRINTF(3, "%s highest metric %d\n",
-	      __func__, metric_counter)
+	      __func__, metric_counter);
 #endif
  
   while(delete_kernel_list!=NULL)
@@ -497,7 +480,7 @@
 #ifdef DEBUG
 		  OLSR_PRINTF(3, "Deleting route to %s hopcount %d\n",
 			      olsr_ip_to_string(&destination_ptr->destination->rt_dst),
-			      destination_ptr->destination->rt_metric)
+			      destination_ptr->destination->rt_metric);
 #endif
 		    if(!olsr_cnf->host_emul)
 		      {
@@ -508,8 +491,9 @@
 			
 			if(error < 0)
 			  {
-			    OLSR_PRINTF(1, "Delete route(%s):%s\n", olsr_ip_to_string(&destination_ptr->destination->rt_dst), strerror(errno))
-			      olsr_syslog(OLSR_LOG_ERR, "Delete route:%m");
+                            const char * const err_msg = strerror(errno);
+			    OLSR_PRINTF(1, "Delete route(%s):%s\n", olsr_ip_to_string(&destination_ptr->destination->rt_dst), err_msg);
+                            olsr_syslog(OLSR_LOG_ERR, "Delete route:%s", err_msg);
 			  }
 		    }
 		  
@@ -582,7 +566,7 @@
 #ifdef DEBUG
 	      OLSR_PRINTF(3, "Adding route to %s hopcount %d\n",
 			  olsr_ip_to_string(&destination_kernel->destination->rt_dst),
-			  destination_kernel->destination->rt_metric)
+			  destination_kernel->destination->rt_metric);
 #endif
 			  
 		if(!olsr_cnf->host_emul)
@@ -594,8 +578,9 @@
 		    
 		    if(error < 0)
 		      {
-			OLSR_PRINTF(1, "Add route(%s): %s\n", olsr_ip_to_string(&destination_kernel->destination->rt_dst), strerror(errno))
-			  olsr_syslog(OLSR_LOG_ERR, "Add route:%m");
+                        const char * const err_msg = strerror(errno);
+			OLSR_PRINTF(1, "Add route(%s): %s\n", olsr_ip_to_string(&destination_kernel->destination->rt_dst), err_msg);
+                        olsr_syslog(OLSR_LOG_ERR, "Add route:%s", err_msg);
 		      }
 		  }
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/rebuild_packet.c olsrd-current/src/rebuild_packet.c
--- olsrd-0.5.0/src/rebuild_packet.c	2005-05-28 18:01:14.000000000 +0200
+++ olsrd-current/src/rebuild_packet.c	2007-04-26 00:08:13.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: rebuild_packet.c,v 1.19 2005/05/28 16:01:14 kattemat Exp $
+ * $Id: rebuild_packet.c,v 1.21 2007/04/25 22:08:13 bernd67 Exp $
  */
 
 
@@ -230,15 +230,15 @@
       
       if(olsr_cnf->debug_level > 1)
 	{
-	  OLSR_PRINTF(3, "Alias list for %s: ", ip_to_string(&mmsg->mid_origaddr.v4))
-	  OLSR_PRINTF(3, "%s", ip_to_string(&mmsg->addr.v4))
+	  OLSR_PRINTF(3, "Alias list for %s: ", ip_to_string(&mmsg->mid_origaddr.v4));
+	  OLSR_PRINTF(3, "%s", ip_to_string(&mmsg->addr.v4));
 	  alias_tmp = mmsg->mid_addr;
 	  while(alias_tmp)
 	    {
-	      OLSR_PRINTF(3, " - %s", ip_to_string(&alias_tmp->alias_addr.v4))
+	      OLSR_PRINTF(3, " - %s", ip_to_string(&alias_tmp->alias_addr.v4));
 	      alias_tmp = alias_tmp->next;
 	    }
-	  OLSR_PRINTF(3, "\n")
+	  OLSR_PRINTF(3, "\n");
 	}
     }
   else
@@ -282,16 +282,16 @@
 
       if(olsr_cnf->debug_level > 1)
 	{
-	  OLSR_PRINTF(3, "Alias list for %s", ip6_to_string(&mmsg->mid_origaddr.v6))
-	  OLSR_PRINTF(3, "%s", ip6_to_string(&mmsg->addr.v6))
+	  OLSR_PRINTF(3, "Alias list for %s", ip6_to_string(&mmsg->mid_origaddr.v6));
+	  OLSR_PRINTF(3, "%s", ip6_to_string(&mmsg->addr.v6));
 
 	  alias_tmp = mmsg->mid_addr;
 	  while(alias_tmp)
 	    {
-	      OLSR_PRINTF(3, " - %s", ip6_to_string(&alias_tmp->alias_addr.v6))
+	      OLSR_PRINTF(3, " - %s", ip6_to_string(&alias_tmp->alias_addr.v6));
 	      alias_tmp = alias_tmp->next;
 	    }
-	  OLSR_PRINTF(3, "\n")
+	  OLSR_PRINTF(3, "\n");
 	}
     }
 
@@ -381,7 +381,7 @@
       /* Willingness */
       hmsg->willingness = m->v4.message.hello.willingness;
 
-      OLSR_PRINTF(3, "Got HELLO vtime: %f htime: %f\n", hmsg->vtime, hmsg->htime)
+      OLSR_PRINTF(3, "Got HELLO vtime: %f htime: %f\n", hmsg->vtime, hmsg->htime);
 
       for (hinf = m->v4.message.hello.hell_info; 
 	   (char *)hinf < ((char *)m + (ntohs(m->v4.olsr_msgsize))); 
@@ -425,7 +425,7 @@
       /* Willingness */
       hmsg->willingness = m->v6.message.hello.willingness;
 
-      OLSR_PRINTF(3, "Got HELLO vtime: %f htime: %f\n", hmsg->vtime, hmsg->htime)
+      OLSR_PRINTF(3, "Got HELLO vtime: %f htime: %f\n", hmsg->vtime, hmsg->htime);
 
 
       for (hinf6 = m->v6.message.hello.hell_info; 
@@ -479,7 +479,7 @@
   if(olsr_cnf->ip_version == AF_INET)
     {
       /* IPv4 */
-      struct tcmsg *tc;
+      struct olsr_tcmsg *tc;
       struct neigh_info *mprsaddr, *maddr;
 
       tc = &m->v4.message.tc;
@@ -498,7 +498,7 @@
       /* Get vtime */
       tmsg->vtime = ME_TO_DOUBLE(m->v4.olsr_vtime);
 
-      OLSR_PRINTF(3, "Got TC vtime: %f\n", tmsg->vtime)
+      OLSR_PRINTF(3, "Got TC vtime: %f\n", tmsg->vtime);
 
       COPY_IP(&tmsg->originator, &m->v4.originator);
       tmsg->packet_seq_number = ntohs(m->v4.seqno);
@@ -520,7 +520,7 @@
   else
     {
       /* IPv6 */
-      struct tcmsg6 *tc6;
+      struct olsr_tcmsg6 *tc6;
       struct neigh_info6 *mprsaddr6, *maddr6;
 
       tc6 = &m->v6.message.tc;
@@ -540,7 +540,7 @@
       /* Get vtime */
       tmsg->vtime = ME_TO_DOUBLE(m->v6.olsr_vtime);
 
-      OLSR_PRINTF(3, "Got TC vtime: %f\n", tmsg->vtime)
+      OLSR_PRINTF(3, "Got TC vtime: %f\n", tmsg->vtime);
 
       COPY_IP(&tmsg->originator, &m->v6.originator);
       tmsg->packet_seq_number = ntohs(m->v6.seqno);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/routing_table.c olsrd-current/src/routing_table.c
--- olsrd-0.5.0/src/routing_table.c	2007-02-10 20:27:32.000000000 +0100
+++ olsrd-current/src/routing_table.c	2007-04-26 00:08:14.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: routing_table.c,v 1.25 2007/02/10 19:27:32 bernd67 Exp $
+ * $Id: routing_table.c,v 1.27 2007/04/25 22:08:14 bernd67 Exp $
  */
 
 
@@ -48,6 +48,7 @@
 #include "neighbor_table.h"
 #include "olsr.h"
 #include "link_set.h"
+#include "routing_table.h"
 
 
 struct rt_entry routingtable[HASHSIZE];
@@ -82,10 +83,9 @@
  *Initialize the routing table
  */
 int
-olsr_init_routing_table()
+olsr_init_routing_table(void)
 {
   int index;
-
   /*
    *The hna routes hash will almost always
    *be indexed to 0
@@ -116,9 +116,7 @@
 {
 
   struct rt_entry *rt_table;
-  olsr_u32_t      hash;
-
-  hash = olsr_hashing(dst);
+  olsr_u32_t      hash = olsr_hashing(dst);
 
   for(rt_table = routingtable[hash].next;
       rt_table != &routingtable[hash];
@@ -126,10 +124,10 @@
     {
       if (COMP_IP(&rt_table->rt_dst, dst))
 	{
-	  return(rt_table);
+	  return rt_table;
 	}
     }
-  return(NULL);
+  return NULL;
   
 }
 
@@ -249,23 +247,21 @@
  *@return
  */
 static int
-olsr_fill_routing_table_with_neighbors()
+olsr_fill_routing_table_with_neighbors(void)
 {
-  olsr_u8_t              index;
+  int index;
 
 #ifdef DEBUG
-  OLSR_PRINTF(7, "FILL ROUTING TABLE WITH NEIGHBORS\n")
+  OLSR_PRINTF(7, "FILL ROUTING TABLE WITH NEIGHBORS\n");
 #endif
 
   for(index=0;index<HASHSIZE;index++)
     {
       struct neighbor_entry *neighbor;
-
       for(neighbor = neighbortable[index].next;
 	  neighbor != &neighbortable[index];
 	  neighbor=neighbor->next)     
 	{
-
 	  if(neighbor->status == SYM)
 	    {
 	      static struct mid_address addrs;
@@ -277,13 +273,12 @@
 
 	      COPY_IP(&addrs.alias, &neighbor->neighbor_main_addr);
 	      addrs.next_alias = mid_lookup_aliases(&neighbor->neighbor_main_addr);
-	      addrs2 = &addrs;
 
-	      while(addrs2!=NULL)
+	      for(addrs2 = &addrs;addrs2!=NULL;addrs2 = addrs2->next_alias)
 		{
 		  struct link_entry *link = get_best_link_to_neighbor(&addrs2->alias);
 #ifdef DEBUG
-		  OLSR_PRINTF(7, "(ROUTE)Adding neighbor %s\n", olsr_ip_to_string(&addrs.alias))
+		  OLSR_PRINTF(7, "(ROUTE)Adding neighbor %s\n", olsr_ip_to_string(&addrs.alias));
 #endif
 		  if(link)
 		    {
@@ -298,14 +293,10 @@
 						    -1.0);
 			}
 		    }
-	      
-		  addrs2 = addrs2->next_alias;
 		}
 	    }
 	}
     }
-
-
   return 1;
 }
 
@@ -342,10 +333,10 @@
  */
 
 static struct destination_n *
-olsr_fill_routing_table_with_two_hop_neighbors()
+olsr_fill_routing_table_with_two_hop_neighbors(void)
 {
   struct destination_n *list_destination_n=NULL;
-  olsr_u8_t            index;
+  int            index;
 
   //printf("FILL ROUTING TABLE WITH TWO HOP NEIGHBORS\n");
 
@@ -378,7 +369,7 @@
 	      if(olsr_lookup_routing_table(n2_addr))
 		{
 #ifdef DEBUG
-		  OLSR_PRINTF(7, "2hop: %s already added\n", olsr_ip_to_string(n2_addr))
+		  OLSR_PRINTF(7, "2hop: %s already added\n", olsr_ip_to_string(n2_addr));
 #endif
 		  continue;
 		}	    
@@ -386,23 +377,22 @@
 	      if(!two_hop_neighbor_reachable(neigh_2_list))
 		{
 		  OLSR_PRINTF(1, "Two hop neighbor %s not added - no one hop neighbors.\n",
-			      olsr_ip_to_string(n2_addr))
+			      olsr_ip_to_string(n2_addr));
 		  continue;
 		}
 
 	      COPY_IP(&addrs.alias, n2_addr);
 	      addrs.next_alias = mid_lookup_aliases(n2_addr);
-	      addrsp = &addrs;
 
-	      while(addrsp!=NULL)
+	      for(addrsp = &addrs; addrsp; addrsp = addrsp->next_alias)
 		{
 		  struct link_entry *link = get_best_link_to_neighbor(&neighbor->neighbor_main_addr);
 #ifdef DEBUG
-		  OLSR_PRINTF(7, "(ROUTE)Adding neighbor %s\n", olsr_ip_to_string(&addrsp->alias))
+		  OLSR_PRINTF(7, "(ROUTE)Adding neighbor %s\n", olsr_ip_to_string(&addrsp->alias));
 #endif
 		  if(link)
 		    {
-		    struct interface *iface = link->if_name ? if_ifwithname(link->if_name) :
+                      struct interface *iface = link->if_name ? if_ifwithname(link->if_name) :
 		                                if_ifwithaddr(&link->local_iface_addr);
 		      if(iface)
 			{
@@ -415,47 +405,39 @@
 			  
 			  if(new_route_entry != NULL)
 			    {
-			      struct destination_n *list_destination_tmp;
-			      list_destination_tmp = olsr_malloc(sizeof(struct destination_n), 
-								 "Fill rt table 2 hop tmp");
-			      
-			      list_destination_tmp->destination = new_route_entry;
-			      list_destination_tmp->next = list_destination_n;
-			      list_destination_n = list_destination_tmp;
+			      struct destination_n *tmp = olsr_malloc(sizeof(struct destination_n), 
+                                                                      "Fill rt table 2 hop tmp");
+			      tmp->destination = new_route_entry;
+			      tmp->next = list_destination_n;
+			      list_destination_n = tmp;
 			    }
 			}
 		    }
-		  addrsp = addrsp->next_alias; 
 		}
 	    }
-	}
-      
+	}      
     }
-  
   return list_destination_n;
 }
 
-
-
-
 /**
  *Recalculate the routing table
  *
  *@return nada
  */
 void 
-olsr_calculate_routing_table()
+olsr_calculate_routing_table(void)
 {
-  struct destination_n *list_destination_n_1 = NULL;
+  struct destination_n *list_destination_n_1;
 
   olsr_move_route_table(routingtable, old_routes);
 
   /* Add neighbors */
   olsr_fill_routing_table_with_neighbors();
   /* Add two hop enighbors - now they are the "outer rim" */
+  
   list_destination_n_1 = olsr_fill_routing_table_with_two_hop_neighbors();
-
-  while(list_destination_n_1!=NULL)
+  while(list_destination_n_1)
     {
       /* List_destination_n_1 holds the "outer rim" */
       struct destination_n *list_destination_n = list_destination_n_1;
@@ -496,8 +478,8 @@
 			{
 			  /* PRINT OUT: Last Hop to Final Destination */
 			  /* The function ip_to_string has to be seperately */
-			  OLSR_PRINTF(3, "%s -> ", olsr_ip_to_string(&list_destination_n->destination->rt_dst))
-			  OLSR_PRINTF(3, "%s\n", olsr_ip_to_string(&tmp_addrsp->alias))
+			  OLSR_PRINTF(3, "%s -> ", olsr_ip_to_string(&list_destination_n->destination->rt_dst));
+			  OLSR_PRINTF(3, "%s\n", olsr_ip_to_string(&tmp_addrsp->alias));
 			  
 			  destination_n_1 = olsr_malloc(sizeof(struct destination_n), 
 							"Calculate routing table 2");
@@ -643,17 +625,16 @@
  *
  */
 void
-olsr_calculate_hna_routes()
+olsr_calculate_hna_routes(void)
 {
-  olsr_u32_t index;
+  int index;
 
 #ifdef DEBUG
-  OLSR_PRINTF(3, "Calculating HNA routes\n")
+  OLSR_PRINTF(3, "Calculating HNA routes\n");
 #endif
 
   olsr_move_route_table(hna_routes, old_hna);
 
-  
   for(index=0;index<HASHSIZE;index++)
     {
       struct hna_entry *tmp_hna;
@@ -674,15 +655,11 @@
 
 	      /* If no route to gateway - skip */
 	      if((tmp_rt = olsr_lookup_routing_table(&tmp_hna->A_gateway_addr)) == NULL)
-		{
 		  continue;
-		}
 
 	      /* If there exists a better or equal entry - skip */
 	      if(olsr_check_for_higher_quality(hna_routes, tmp_net, tmp_rt->rt_etx) != NULL)
-		{
 		  continue;
-		}
 
 	      /* If we find an entry with lower quality we just edit it */
 	      if((new_rt = olsr_check_for_lower_quality(hna_routes, tmp_net, tmp_rt->rt_etx)) != NULL)
@@ -739,12 +716,11 @@
 
   if(olsr_cnf->debug_level > 2)
     {
-      OLSR_PRINTF(3, "HNA table:\n")
+      OLSR_PRINTF(3, "HNA table:\n");
       olsr_print_routing_table(hna_routes);
     }
 
   olsr_free_routing_table(old_hna);
-
 }
 
 
@@ -759,12 +735,11 @@
 void
 olsr_print_routing_table(struct rt_entry *table)
 {
-
-  olsr_u8_t index;
+  int index;
 
   printf("ROUTING TABLE\n");
   printf("DESTINATION\tNEXT HOP\tHOPCNT\tINTERFACE\n");
-  for(index=0;index<HASHSIZE;index++)
+  for(index = 0; index < HASHSIZE; index++)
     {
       struct rt_entry *destination;
       for(destination = table[index].next;
@@ -779,8 +754,3 @@
 	}
     }
 }
-
-
-
-
-
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/scheduler.c olsrd-current/src/scheduler.c
--- olsrd-0.5.0/src/scheduler.c	2007-01-31 13:36:50.000000000 +0100
+++ olsrd-current/src/scheduler.c	2007-04-26 00:08:16.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: scheduler.c,v 1.37 2007/01/31 12:36:50 bernd67 Exp $
+ * $Id: scheduler.c,v 1.39 2007/04/25 22:08:16 bernd67 Exp $
  */
 
 
@@ -77,7 +77,7 @@
 }
 
 static void 
-trigger_dijkstra(void *dummy)
+trigger_dijkstra(void *foo __attribute__((unused)))
 {
   OLSR_PRINTF(3, "Triggering Dijkstra\n");
 
@@ -98,7 +98,7 @@
  */
 
 void
-scheduler()
+scheduler(void)
 {
   struct timespec remainder_spec;
   struct timespec sleeptime_spec;
@@ -132,13 +132,12 @@
   interval.tv_sec = interval_usec / 1000000;
   interval.tv_usec = interval_usec % 1000000;
 
-  OLSR_PRINTF(1, "Scheduler started - polling every %0.2f seconds\n", pollrate)
-  OLSR_PRINTF(3, "Max jitter is %f\n\n", olsr_cnf->max_jitter)
+  OLSR_PRINTF(1, "Scheduler started - polling every %0.2f seconds\n", pollrate);
+  OLSR_PRINTF(3, "Max jitter is %f\n\n", olsr_cnf->max_jitter);
 
   /* Main scheduler event loop */
   for(;;)
     {
-
       /* Update now_times */
       now_times = times(&tms_buf);
 
@@ -170,7 +169,7 @@
       /* Check for changes in topology */
       if(link_changes)
         {
-	  OLSR_PRINTF(3, "ANSN UPDATED %d\n\n", get_local_ansn())
+	  OLSR_PRINTF(3, "ANSN UPDATED %d\n\n", get_local_ansn());
 	  increase_local_ansn();
           link_changes = OLSR_FALSE;
 	}
@@ -201,7 +200,7 @@
 	      if(entry->trigger != NULL)
 		*(entry->trigger) = 0;
 	      
-	      //OLSR_PRINTF(3, "Since_last jitter: %0.2f\n", entry->since_last)
+	      //OLSR_PRINTF(3, "Since_last jitter: %0.2f\n", entry->since_last);
 
 	    }
 
@@ -278,7 +277,7 @@
 {
   struct event_entry *new_entry;
 
-  OLSR_PRINTF(3, "Scheduler event registered int: %0.2f\n", interval)
+  OLSR_PRINTF(3, "Scheduler event registered int: %0.2f\n", interval);
 
   /* check that this entry is not added already */
   new_entry = event_functions;
@@ -314,7 +313,7 @@
 
 /*
  *
- *@param initial how long utnil the first generation
+ *@param initial how long until the first generation
  *@param trigger pointer to a boolean indicating that
  *this function should be triggered immediatley
  */
@@ -322,7 +321,7 @@
 olsr_remove_scheduler_event(void (*event_function)(void *), 
 			    void *par,
 			    float interval, 
-			    float initial, 
+			    float initial __attribute__((unused)), 
 			    olsr_u8_t *trigger)
 {
   struct event_entry *entry, *prev;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/scheduler.h olsrd-current/src/scheduler.h
--- olsrd-0.5.0/src/scheduler.h	2006-01-07 09:16:20.000000000 +0100
+++ olsrd-current/src/scheduler.h	2007-04-20 15:46:04.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: scheduler.h,v 1.12 2006/01/07 08:16:20 kattemat Exp $
+ * $Id: scheduler.h,v 1.13 2007/04/20 13:46:04 bernd67 Exp $
  */
 
 
@@ -84,6 +84,6 @@
 olsr_remove_scheduler_event(void (*)(void *), void *, float, float, olsr_u8_t *);
 
 void
-scheduler(void);
+scheduler(void) __attribute__((noreturn));
 
 #endif
